image: registry.gitlab.com/gdunstone/docker-buildx-qemu

services:
  - name: docker:dind
    entrypoint: ["env", "-u", "DOCKER_HOST"]
    command: ["dockerd-entrypoint.sh"]

stages:
  - build
  - test
  - retag
  - release-image
  - release-code

variables:
  CI_BUILD_ARCHS: linux/arm64/v8,linux/amd64
  DOCKER_DRIVER: overlay2
  DOCKER_HOST: tcp://docker:2375/
  DOCKER_TLS_CERTDIR: ""
  IMAGE_ADDR: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
  IMAGE_CACHE: $CI_REGISTRY_IMAGE/cache:$CI_COMMIT_SHA
  IMAGE_FINAL: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME

build:
  stage: build
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - update-binfmts --enable
    - docker buildx create --driver docker-container --use
    - docker buildx inspect --bootstrap
  script:
    - >
        docker buildx build --platform $CI_BUILD_ARCHS \
            --cache-from=type=registry,ref=$IMAGE_CACHE \
            --cache-to=type=registry,ref=$IMAGE_CACHE \
            --build-arg=DO_UPGRADE=yes \
            --progress plain --pull --push \
            -t "$IMAGE_ADDR" .

test:
  stage: test
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  image: docker:19.03.12
  script:
    - docker run -d --name curator $IMAGE_ADDR --version
    - >
        works=false;
        for try in 1 2 3;
        do
            echo "=== Test $try/3 ==="
            if docker logs curator | grep 'curator, version '; then
                works=true;
                break;
            elif test $try -eq 3; then
                break;
            fi;
            echo retrying in 5 seconds;
            sleep 5;
        done;
        if $works; then
            echo "Test: OK, Curator";
        else
            echo "Test: KO, Curator";
            exit 1;
        fi

retag:
  stage: retag
  image:
    name: quay.io/skopeo/stable
    entrypoint: [""]
  script:
    - >
        skopeo copy \
            --dest-creds=$CI_REGISTRY_USER:$CI_REGISTRY_PASSWORD \
            --src-creds=$CI_REGISTRY_USER:$CI_REGISTRY_PASSWORD \
            docker://$IMAGE_ADDR docker://$IMAGE_FINAL

release-image:
  rules:
    - if: $CI_COMMIT_TAG
  stage: release-image
  image:
    name: quay.io/skopeo/stable
    entrypoint: [""]
  script:
    - >
        skopeo copy --all \
            --src-creds=$CI_REGISTRY_USER:$CI_REGISTRY_PASSWORD \
            --dest-creds=$CI_REGISTRY_USER:$CI_REGISTRY_PASSWORD \
            docker://$IMAGE_ADDR docker://$CI_REGISTRY_IMAGE:$CI_COMMIT_TAG

release-code:
  rules:
    - if: $CI_COMMIT_TAG
  stage: release-code
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  release:
    name: 'Release $CI_COMMIT_TAG'
    description: '$CI_REGISTRY_IMAGE:$CI_COMMIT_TAG'
    ref: '$CI_COMMIT_TAG'
    tag_name: '$CI_COMMIT_TAG'
  script:
    - echo 'Releasing $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG'
